Index: src/tests/.expect/labelledExit.txt
===================================================================
--- src/tests/.expect/labelledExit.txt	(revision c017d5b3313df52e24803e45f64febcb623d9b91)
+++ src/tests/.expect/labelledExit.txt	(revision 177a5cefed68e51aa2e3240e4541facc5f85496d)
@@ -1,177 +1,0 @@
-CFA Version 1.0.0 (debug)
-/tmp/ccYaN2OX.i: In function '__foo__Fi___1':
-/tmp/ccYaN2OX.i:1124:23: warning: this 'for' clause does not guard... [-Wmisleading-indentation]
-     __L20__loopBreak: for (;;) /* null statement */ ;
-                       ^~~
-/tmp/ccYaN2OX.i:1126:5: note: ...this statement, but the latter is misleadingly indented as if it is guarded by the 'for'
-     {
-     ^
-/tmp/ccYaN2OX.i:1180:5: warning: label 'Q' defined but not used [-Wunused-label]
-     Q: if ( ((int )((__i__i_2>5)!=0)) ) {
-     ^
-/tmp/ccYaN2OX.i:1158:5: warning: label 'Choose' defined but not used [-Wunused-label]
-     Choose: switch ( __i__i_2 ) {
-     ^~~~~~
-/tmp/ccYaN2OX.i:1141:5: warning: label 'Switch' defined but not used [-Wunused-label]
-     Switch: switch ( __i__i_2 ) {
-     ^~~~~~
-/tmp/ccYaN2OX.i:1137:160: warning: label 'L34' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                                                                                                                                ^~~
-/tmp/ccYaN2OX.i:1137:155: warning: label 'L33' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                                                                                                                           ^~~
-/tmp/ccYaN2OX.i:1137:150: warning: label 'L32' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                                                                                                                      ^~~
-/tmp/ccYaN2OX.i:1137:145: warning: label 'L31' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                                                                                                                 ^~~
-/tmp/ccYaN2OX.i:1137:140: warning: label 'L29' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                                                                                                            ^~~
-/tmp/ccYaN2OX.i:1137:135: warning: label 'L28' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                                                                                                       ^~~
-/tmp/ccYaN2OX.i:1137:130: warning: label 'L27' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                                                                                                  ^~~
-/tmp/ccYaN2OX.i:1137:125: warning: label 'L26' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                                                                                             ^~~
-/tmp/ccYaN2OX.i:1137:120: warning: label 'L25' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                                                                                        ^~~
-/tmp/ccYaN2OX.i:1137:115: warning: label 'L24' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                                                                                   ^~~
-/tmp/ccYaN2OX.i:1137:110: warning: label 'L23' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                                                                              ^~~
-/tmp/ccYaN2OX.i:1137:105: warning: label 'L22' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                                                                         ^~~
-/tmp/ccYaN2OX.i:1137:100: warning: label 'L21' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                                                                    ^~~
-/tmp/ccYaN2OX.i:1137:95: warning: label 'L20' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                                                               ^~~
-/tmp/ccYaN2OX.i:1137:90: warning: label 'L19' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                                                          ^~~
-/tmp/ccYaN2OX.i:1137:85: warning: label 'L18' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                                                     ^~~
-/tmp/ccYaN2OX.i:1137:80: warning: label 'L17' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                                                ^~~
-/tmp/ccYaN2OX.i:1137:75: warning: label 'L16' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                                           ^~~
-/tmp/ccYaN2OX.i:1137:70: warning: label 'L15' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                                      ^~~
-/tmp/ccYaN2OX.i:1137:65: warning: label 'L14' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                                 ^~~
-/tmp/ccYaN2OX.i:1137:60: warning: label 'L13' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                            ^~~
-/tmp/ccYaN2OX.i:1137:55: warning: label 'L12' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                       ^~~
-/tmp/ccYaN2OX.i:1137:50: warning: label 'L11' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                                  ^~~
-/tmp/ccYaN2OX.i:1137:45: warning: label 'L10' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                             ^~~
-/tmp/ccYaN2OX.i:1137:41: warning: label 'L9' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                         ^~
-/tmp/ccYaN2OX.i:1137:37: warning: label 'L8' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                     ^~
-/tmp/ccYaN2OX.i:1137:33: warning: label 'L7' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                                 ^~
-/tmp/ccYaN2OX.i:1137:29: warning: label 'L6' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                             ^~
-/tmp/ccYaN2OX.i:1137:25: warning: label 'L5' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                         ^~
-/tmp/ccYaN2OX.i:1137:21: warning: label 'L4' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                     ^~
-/tmp/ccYaN2OX.i:1137:17: warning: label 'L3' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-                 ^~
-/tmp/ccYaN2OX.i:1137:13: warning: label 'L2' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-             ^~
-/tmp/ccYaN2OX.i:1137:9: warning: label 'L1' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-         ^~
-/tmp/ccYaN2OX.i:1137:5: warning: label 'L0' defined but not used [-Wunused-label]
-     L0: L1: L2: L3: L4: L5: L6: L7: L8: L9: L10: L11: L12: L13: L14: L15: L16: L17: L18: L19: L20: L21: L22: L23: L24: L25: L26: L27: L28: L29: L31: L32: L33: L34: for (;;) {
-     ^~
-/tmp/ccYaN2OX.i:1097:13: warning: label 'ZZ' defined but not used [-Wunused-label]
-             ZZ: for (;;) {
-             ^~
-/tmp/ccYaN2OX.i:1096:9: warning: label 'YY' defined but not used [-Wunused-label]
-         YY: for (;;) {
-         ^~
-/tmp/ccYaN2OX.i:1095:5: warning: label 'XX' defined but not used [-Wunused-label]
-     XX: for (;;) {
-     ^~
-/tmp/ccYaN2OX.i:1084:8: warning: label 'Y' defined but not used [-Wunused-label]
-     X: Y: for (;;) {
-        ^
-/tmp/ccYaN2OX.i:1084:5: warning: label 'X' defined but not used [-Wunused-label]
-     X: Y: for (;;) {
-     ^
-/tmp/ccYaN2OX.i:1077:8: warning: label '__L9__blockBreak' defined but not used [-Wunused-label]
-     D: __L9__blockBreak: for (;;) {
-        ^~~~~~~~~~~~~~~~
-/tmp/ccYaN2OX.i:1077:5: warning: label 'D' defined but not used [-Wunused-label]
-     D: __L9__blockBreak: for (;;) {
-     ^
-/tmp/ccYaN2OX.i:1028:5: warning: label 'w2' defined but not used [-Wunused-label]
-     w2: while (((int )((__x__i_2<10)!=0))) {
-     ^~
-/tmp/ccYaN2OX.i:1026:5: warning: label 'w1' defined but not used [-Wunused-label]
-     w1: __L0__blockBreak: while (((int )((__y__i_2==10)!=0))) /* null statement */ ;
-     ^~
-/tmp/ccYaN2OX.i:1014:5: warning: label 'Block' defined but not used [-Wunused-label]
-     Block: {
-     ^~~~~
-/tmp/ccYaN2OX.i:1016:13: warning: '__i__i_2' may be used uninitialized in this function [-Wmaybe-uninitialized]
-             for (;((int )((__i__i_2<__y__i_2)!=0));) {
-             ^~~
-/usr/bin/ld: /usr/lib/debug/usr/lib/x86_64-linux-gnu/crt1.o(.debug_info): relocation 0 has invalid symbol index 10
-/usr/bin/ld: /usr/lib/debug/usr/lib/x86_64-linux-gnu/crt1.o(.debug_info): relocation 1 has invalid symbol index 11
-/usr/bin/ld: /usr/lib/debug/usr/lib/x86_64-linux-gnu/crt1.o(.debug_info): relocation 2 has invalid symbol index 2
-/usr/bin/ld: /usr/lib/debug/usr/lib/x86_64-linux-gnu/crt1.o(.debug_info): relocation 3 has invalid symbol index 2
-/usr/bin/ld: /usr/lib/debug/usr/lib/x86_64-linux-gnu/crt1.o(.debug_info): relocation 4 has invalid symbol index 10
-/usr/bin/ld: /usr/lib/debug/usr/lib/x86_64-linux-gnu/crt1.o(.debug_info): relocation 5 has invalid symbol index 12
-/usr/bin/ld: /usr/lib/debug/usr/lib/x86_64-linux-gnu/crt1.o(.debug_info): relocation 6 has invalid symbol index 12
-/usr/bin/ld: /usr/lib/debug/usr/lib/x86_64-linux-gnu/crt1.o(.debug_info): relocation 7 has invalid symbol index 12
-/usr/bin/ld: /usr/lib/debug/usr/lib/x86_64-linux-gnu/crt1.o(.debug_info): relocation 8 has invalid symbol index 2
-/usr/bin/ld: /usr/lib/debug/usr/lib/x86_64-linux-gnu/crt1.o(.debug_info): relocation 9 has invalid symbol index 2
-/usr/bin/ld: /usr/lib/debug/usr/lib/x86_64-linux-gnu/crt1.o(.debug_info): relocation 10 has invalid symbol index 11
-/usr/bin/ld: /usr/lib/debug/usr/lib/x86_64-linux-gnu/crt1.o(.debug_info): relocation 11 has invalid symbol index 12
-/usr/bin/ld: /usr/lib/debug/usr/lib/x86_64-linux-gnu/crt1.o(.debug_info): relocation 12 has invalid symbol index 12
-/usr/bin/ld: /usr/lib/debug/usr/lib/x86_64-linux-gnu/crt1.o(.debug_info): relocation 13 has invalid symbol index 12
-/usr/bin/ld: /usr/lib/debug/usr/lib/x86_64-linux-gnu/crt1.o(.debug_info): relocation 14 has invalid symbol index 12
-/usr/bin/ld: /usr/lib/debug/usr/lib/x86_64-linux-gnu/crt1.o(.debug_info): relocation 15 has invalid symbol index 12
-/usr/bin/ld: /usr/lib/debug/usr/lib/x86_64-linux-gnu/crt1.o(.debug_info): relocation 16 has invalid symbol index 12
-/usr/bin/ld: /usr/lib/debug/usr/lib/x86_64-linux-gnu/crt1.o(.debug_info): relocation 17 has invalid symbol index 12
-/usr/bin/ld: /usr/lib/debug/usr/lib/x86_64-linux-gnu/crt1.o(.debug_info): relocation 18 has invalid symbol index 12
-/usr/bin/ld: /usr/lib/debug/usr/lib/x86_64-linux-gnu/crt1.o(.debug_info): relocation 19 has invalid symbol index 12
-/usr/bin/ld: /usr/lib/debug/usr/lib/x86_64-linux-gnu/crt1.o(.debug_info): relocation 20 has invalid symbol index 19
-/usr/lib/gcc/x86_64-linux-gnu/6/../../../x86_64-linux-gnu/crt1.o: In function `_start':
-(.text+0x20): undefined reference to `main'
-collect2: error: ld returned 1 exit status
-make: *** [labelledExit] Error 1