Index: src/CodeGen/CodeGenerator.cc
===================================================================
--- src/CodeGen/CodeGenerator.cc	(revision 6e300d9344402086f842815a9d92112caf82ac54)
+++ src/CodeGen/CodeGenerator.cc	(revision 262f085f5bcbf8161e794c370badc1a66ccb3991)
@@ -9,7 +9,7 @@
 // Author           : Richard C. Bilson
 // Created On       : Mon May 18 07:44:20 2015
-// Last Modified By : Andrew Beach
-// Last Modified On : Tus May  9 14:32:00 2017
-// Update Count     : 483
+// Last Modified By : Peter A. Buhr
+// Last Modified On : Thu Mar 30 16:38:01 2017
+// Update Count     : 482
 //
 
@@ -41,17 +41,4 @@
 namespace CodeGen {
 	int CodeGenerator::tabsize = 4;
-
-	// Pseudo Function: output << lineDirective(*currentNode);
-    struct lineDirective {
-        CodeLocation const & loc;
-		lineDirective(CodeLocation const & location) : loc(location) {}
-		lineDirective(BaseSyntaxNode const * node) : loc(node->location) {}
-	};
-	std::ostream & operator<<(std::ostream & out, lineDirective const & ld) {
-		if (ld.loc.isSet())
-			return out << "\n# " << ld.loc.linenumber << " \""
-				<< ld.loc.filename << "\"\n";
-		return out << "\n// Unset Location\n";
-	}
 
 	// the kinds of statements that would ideally be followed by whitespace
@@ -141,5 +128,5 @@
 
 
-	// *** Declarations
+	//*** Declarations
 	void CodeGenerator::visit( FunctionDecl * functionDecl ) {
 		extension( functionDecl );
@@ -195,5 +182,5 @@
 		}
 
-		output << lineDirective( aggDecl ) << kind;
+		output << kind;
 		if ( aggDecl->get_name() != "" )
 			output << aggDecl->get_name();
@@ -205,5 +192,5 @@
 			cur_indent += CodeGenerator::tabsize;
 			for ( std::list< Declaration* >::iterator i = memb.begin(); i != memb.end(); i++ ) {
-				output << lineDirective( *i ) << indent;
+				output << indent;
 				(*i)->accept( *this );
 				output << ";" << endl;
@@ -228,5 +215,4 @@
 	void CodeGenerator::visit( EnumDecl * enumDecl ) {
 		extension( enumDecl );
-		output << lineDirective ( enumDecl );
 		output << "enum ";
 		genAttributes( enumDecl->get_attributes() );
@@ -244,5 +230,5 @@
 				ObjectDecl * obj = dynamic_cast< ObjectDecl* >( *i );
 				assert( obj );
-				output << lineDirective( obj ) << indent << mangleName( obj );
+				output << indent << mangleName( obj );
 				if ( obj->get_init() ) {
 					output << " = ";
@@ -262,5 +248,4 @@
 	void CodeGenerator::visit( TypedefDecl * typeDecl ) {
 		assertf( ! genC, "Typedefs are removed and substituted in earlier passes." );
-		output << lineDirective( typeDecl );
 		output << "typedef ";
 		output << genType( typeDecl->get_base(), typeDecl->get_name(), pretty, genC ) << endl;
@@ -334,5 +319,5 @@
 	}
 
-	// *** Expressions
+	//*** Expressions
 	void CodeGenerator::visit( ApplicationExpr * applicationExpr ) {
 		extension( applicationExpr );
@@ -737,11 +722,10 @@
 	void CodeGenerator::visit( StmtExpr * stmtExpr ) {
 		std::list< Statement * > & stmts = stmtExpr->get_statements()->get_kids();
-		output << lineDirective( stmtExpr) << "({" << std::endl;
+		output << "({" << std::endl;
 		cur_indent += CodeGenerator::tabsize;
 		unsigned int numStmts = stmts.size();
 		unsigned int i = 0;
 		for ( Statement * stmt : stmts ) {
-			output << lineDirective( stmt ) << indent;
-            output << printLabels( stmt->get_labels() );
+			output << indent << printLabels( stmt->get_labels() );
 			if ( i+1 == numStmts ) {
 				// last statement in a statement expression needs to be handled specially -
@@ -765,5 +749,5 @@
 	}
 
-	// *** Statements
+	//*** Statements
 	void CodeGenerator::visit( CompoundStmt * compoundStmt ) {
 		std::list<Statement*> ks = compoundStmt->get_kids();
@@ -829,5 +813,4 @@
 
 	void CodeGenerator::visit( IfStmt * ifStmt ) {
-		output << lineDirective( ifStmt );
 		output << "if ( ";
 		ifStmt->get_condition()->accept( *this );
@@ -843,5 +826,4 @@
 
 	void CodeGenerator::visit( SwitchStmt * switchStmt ) {
-		output << lineDirective( switchStmt );
 		output << "switch ( " ;
 		switchStmt->get_condition()->accept( *this );
@@ -856,5 +838,4 @@
 
 	void CodeGenerator::visit( CaseStmt * caseStmt ) {
-		output << lineDirective( caseStmt );
 		output << indent;
 		if ( caseStmt->isDefault()) {